.template-build-linux:
  stage: build
  extends:
    - .defaults
    - .test-artifacts

  variables:
    CCACHE_DIR: "$CI_PROJECT_DIR/.ccache"

  before_script:
    - mkdir -p $BUILD_DIR
    - cd $BUILD_DIR

  script:
    - >
      cmake .. -G Ninja
      $CMAKE_ARGS
      -DCMAKE_BUILD_TYPE=$BUILD_TYPE
      -DOGS_BUILD_PROCESSES=$BUILD_PROCESSES
    - cmake --build . > >(tee make.output)
    - cmake --build . --target tests
    - cmake --build . --target ctest
    - cp Testing/**/Test.xml Tests/ctest.xml

  cache:
    paths:
      - $CCACHE_DIR
